<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="100px" size="medium" class="ry_form">
      <el-form-item label="提示框背景图片" prop="partnerBackground">
        <el-input
          v-model="queryParams.partnerBackground"
          placeholder="请输入提示框背景图片"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="提示框背景文本" prop="prompt">
        <el-input
          v-model="queryParams.prompt"
          placeholder="请输入提示框背景文本"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="加入成功提示文本" prop="promptText">
        <el-input
          v-model="queryParams.promptText"
          placeholder="请输入加入成功提示文本"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item class="flex_one tr">
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['model:indexPartnerConfig:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['model:indexPartnerConfig:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['model:indexPartnerConfig:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['model:indexPartnerConfig:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList" :columns="columns"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="indexPartnerConfigList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="提示框背景图片" align="center" prop="partnerBackground" v-if="columns[0].visible"/>
      <el-table-column label="提示框背景文本" align="center" prop="prompt" v-if="columns[1].visible"/>
      <el-table-column label="加入成功提示文本" align="center" prop="promptText" v-if="columns[2].visible"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['model:indexPartnerConfig:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['model:indexPartnerConfig:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改加入合伙人提示配置对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="50%" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="108px" inline class="dialog-form-two">
        <el-form-item label="提示框背景图片" prop="partnerBackground">
          <el-input v-model="form.partnerBackground" placeholder="请输入提示框背景图片" />
        </el-form-item>
        <el-form-item label="提示框背景文本" prop="prompt">
          <el-input v-model="form.prompt" placeholder="请输入提示框背景文本" />
        </el-form-item>
        <el-form-item label="加入成功提示文本" prop="promptText">
          <el-input v-model="form.promptText" placeholder="请输入加入成功提示文本" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listIndexPartnerConfig, getIndexPartnerConfig, delIndexPartnerConfig, addIndexPartnerConfig, updateIndexPartnerConfig, exportIndexPartnerConfig } from "@/api/model/indexPartnerConfig";

export default {
  name: "IndexPartnerConfig",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 加入合伙人提示配置表格数据
      indexPartnerConfigList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        partnerBackground: null,

        prompt: null,

        promptText: null,

      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      columns: [
    { key: 0, label: "提示框背景图片", visible:  true  },
    { key: 1, label: "提示框背景文本", visible:  true  },
    { key: 2, label: "加入成功提示文本", visible:  true  },
     ],
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询加入合伙人提示配置列表 */
    getList() {
      this.loading = true;
      listIndexPartnerConfig(this.queryParams).then(response => {
        this.indexPartnerConfigList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        partnerBackground: null,

        prompt: null,

        promptText: null,

      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.partnerBackground)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加加入合伙人提示配置";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const partnerBackground = row.partnerBackground || this.ids
      getIndexPartnerConfig(partnerBackground).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改加入合伙人提示配置";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.partnerBackground != null) {
            updateIndexPartnerConfig(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addIndexPartnerConfig(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const partnerBackgrounds = row.partnerBackground || this.ids;
      this.$modal.confirm('是否确认删除加入合伙人提示配置编号为"' + partnerBackgrounds + '"的数据项？').then(function() {
        return delIndexPartnerConfig(partnerBackgrounds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$modal.confirm('是否确认导出所有加入合伙人提示配置数据项？').then(() => {
        this.exportLoading = true;
        return exportIndexPartnerConfig(queryParams);
      }).then(response => {
        this.download(response.msg);
        this.exportLoading = false;
      }).catch(() => {});
    }
  }
};
</script>
